module("luci.passwall.util_trojan",package.seeall)
local a=require"luci.passwall.api"
local o=a.uci
local h=a.jsonc
function gen_config_server(e)
local t="ECDHE-ECDSA-AES128-GCM-SHA256:ECDHE-RSA-AES128-GCM-SHA256:ECDHE-ECDSA-CHACHA20-POLY1305:ECDHE-RSA-CHACHA20-POLY1305:ECDHE-ECDSA-AES256-GCM-SHA384:ECDHE-RSA-AES256-GCM-SHA384:ECDHE-ECDSA-AES256-SHA:ECDHE-ECDSA-AES128-SHA:ECDHE-RSA-AES128-SHA:ECDHE-RSA-AES256-SHA:DHE-RSA-AES128-SHA:DHE-RSA-AES256-SHA:AES128-SHA:AES256-SHA:DES-CBC3-SHA"
local a="TLS_AES_128_GCM_SHA256:TLS_CHACHA20_POLY1305_SHA256:TLS_AES_256_GCM_SHA384"
local t={
run_type="server",
local_addr="::",
local_port=tonumber(e.port),
remote_addr=(e.remote_enable=="1"and e.remote_address)and e.remote_address or nil,
remote_port=(e.remote_enable=="1"and e.remote_port)and tonumber(e.remote_port)or nil,
password=e.uuid,
log_level=(e.log and e.log=="1")and tonumber(e.loglevel)or 5,
ssl={
cert=e.tls_certificateFile,
key=e.tls_keyFile,
key_password="",
cipher=t,
cipher_tls13=a,
prefer_server_cipher=true,
reuse_session=true,
session_ticket=(e.tls_sessionTicket=="1")and true or false,
session_timeout=600,
plain_http_response="",
curves="",
dhparam=""
},
tcp={
prefer_ipv4=false,
no_delay=true,
keep_alive=true,
reuse_port=false,
fast_open=(e.tcp_fast_open and e.tcp_fast_open=="1")and true or false,
fast_open_qlen=20
}
}
if e.type=="Trojan-Go"then
t.ssl.cipher=nil
t.ssl.cipher_tls13=nil
t.udp_timeout=60
t.disable_http_check=true
t.transport_plugin=((e.tls==nil or e.tls~="1")and e.trojan_transport=="original")and{
enabled=e.plugin_type~=nil,
type=e.plugin_type or"plaintext",
command=e.plugin_type~="plaintext"and e.plugin_cmd or nil,
option=e.plugin_type~="plaintext"and e.plugin_option or nil,
arg=e.plugin_type~="plaintext"and{e.plugin_arg}or nil,
env={}
}or nil
t.websocket=(e.trojan_transport=='ws')and{
enabled=true,
path=e.ws_path or"/",
host=e.ws_host or""
}or nil
t.shadowsocks=(e.ss_aead=="1")and{
enabled=true,
method=e.ss_aead_method or"aes_128_gcm",
password=e.ss_aead_pwd or""
}or nil
end
return t
end
function gen_config(t)
local e=t["-node"]
if not e then
print("-node 不能为空")
return
end
local e=o:get_all("passwall",e)
local u=t["-run_type"]
local d=t["-local_addr"]
local l=t["-local_port"]
local o=t["-server_host"]or e.address
local r=t["-server_port"]or e.port
local s=t["-loglevel"]or 2
local i="ECDHE-ECDSA-AES128-GCM-SHA256:ECDHE-RSA-AES128-GCM-SHA256:ECDHE-ECDSA-CHACHA20-POLY1305:ECDHE-RSA-CHACHA20-POLY1305:ECDHE-ECDSA-AES256-GCM-SHA384:ECDHE-RSA-AES256-GCM-SHA384:ECDHE-ECDSA-AES256-SHA:ECDHE-ECDSA-AES128-SHA:ECDHE-RSA-AES128-SHA:ECDHE-RSA-AES256-SHA:DHE-RSA-AES128-SHA:DHE-RSA-AES256-SHA:AES128-SHA:AES256-SHA:DES-CBC3-SHA"
local n="TLS_AES_128_GCM_SHA256:TLS_CHACHA20_POLY1305_SHA256:TLS_AES_256_GCM_SHA384"
if a.is_ipv6(o)then
o=a.get_ipv6_only(o)
end
local a=o
local t={
run_type=u,
local_addr=d,
local_port=tonumber(l),
remote_addr=a,
remote_port=tonumber(r),
password={e.password},
log_level=tonumber(s),
ssl={
verify=(e.tls_allowInsecure~="1")and true or false,
verify_hostname=true,
cert=nil,
cipher=i,
cipher_tls13=n,
sni=e.tls_serverName or a,
alpn={"h2","http/1.1"},
reuse_session=true,
session_ticket=(e.tls_sessionTicket and e.tls_sessionTicket=="1")and true or false,
curves=""
},
udp_timeout=60,
tcp={
use_tproxy=(e.type=="Trojan-Plus"and t["-use_tproxy"])and true or nil,
no_delay=true,
keep_alive=true,
reuse_port=true,
fast_open=(e.tcp_fast_open=="true")and true or false,
fast_open_qlen=20
}
}
if e.type=="Trojan-Go"then
t.ssl.cipher=nil
t.ssl.cipher_tls13=nil
t.ssl.fingerprint=(e.fingerprint~="disable")and e.fingerprint or""
t.ssl.alpn=(e.trojan_transport=='ws')and{}or{"h2","http/1.1"}
if e.tls~="1"and e.trojan_transport=="original"then t.ssl=nil end
t.transport_plugin=((not e.tls or e.tls~="1")and e.trojan_transport=="original")and{
enabled=e.plugin_type~=nil,
type=e.plugin_type or"plaintext",
command=e.plugin_type~="plaintext"and e.plugin_cmd or nil,
option=e.plugin_type~="plaintext"and e.plugin_option or nil,
arg=e.plugin_type~="plaintext"and{e.plugin_arg}or nil,
env={}
}or nil
t.websocket=(e.trojan_transport=='ws')and{
enabled=true,
path=e.ws_path or"/",
host=e.ws_host or(e.tls_serverName or a)
}or nil
t.shadowsocks=(e.ss_aead=="1")and{
enabled=true,
method=e.ss_aead_method or"aes_128_gcm",
password=e.ss_aead_pwd or""
}or nil
t.mux=(e.smux=="1")and{
enabled=true,
concurrency=tonumber(e.mux_concurrency),
idle_timeout=tonumber(e.smux_idle_timeout)
}or nil
end
return h.stringify(t,1)
end
_G.gen_config=gen_config
if arg[1]then
local e=_G[arg[1]]
if e then
print(e(a.get_function_args(arg)))
end
end
